# import all the necessary modules:
import topology as t
import neighborhood as n
import rule as r
import operator as o
import agent as a
import automaton as u
import genome as g
from code import tabula

import visual as v
import curses as c

import distutils.core 
from distutils.extension import Extension
from Pyrex.Distutils import build_ext

import random

# set grid size and number of iterations:
size = (90,40)
(width, height) = size
iterate = 30000

# poeio is a sequence of words from tabula at module code
poeio = ['a','i','z','d','z','n','z','m','z','a','a','w','a','r','a','c','a','a','a','e']
# samskara is a genome binding poeio to tabula
samskara = g.Genome(poeio, tabula, 2)
# corpus is the relative filepath where the compiled genome will be saved
corpus = 'creatures/wanderer.pyx'
# this incantation actually writes the .pyx file with the translated poeio code
samskara.incorporate(corpus)
# create a name for the module object from the .pyx file
species = 'wanderer'

# now we invoke the pyrex compiler to create the module
distutils.core.setup(
	name = species,
	ext_modules = [Extension(species,[corpus])],
	cmdclass = {'build_ext':build_ext}
	) 

# initialise the automaton
annuvin = t.ToroidTopology(size,0)
caer = n.VonNeumannNeighborhood(annuvin)
sidhe = r.ReductionRule(caer,(o.xor,0))
prydain = u.SynchronousAutomaton_2D(sidhe)

# import the module which was dynamically created from the poeio
amatheon = __import__(species)

# create various instances of an agent class defined in poeio
amatheonwy = amatheon.beBorn(annuvin)
gwion = amatheon.beBorn(annuvin)
gwydion = amatheon.beBorn(annuvin)
bran = amatheon.beBorn(annuvin)
amatheonwy1 = amatheon.beBorn(annuvin)
gwion1 = amatheon.beBorn(annuvin)
gwydion1 = amatheon.beBorn(annuvin)
bran1 = amatheon.beBorn(annuvin)
amatheonwy2 = amatheon.beBorn(annuvin)
gwion2 = amatheon.beBorn(annuvin)
gwydion2 = amatheon.beBorn(annuvin)
bran2 = amatheon.beBorn(annuvin)
amatheonwy3 = amatheon.beBorn(annuvin)
gwion3 = amatheon.beBorn(annuvin)
gwydion3 = amatheon.beBorn(annuvin)
bran3 = amatheon.beBorn(annuvin)
amatheonwy4 = amatheon.beBorn(annuvin)
gwion4 = amatheon.beBorn(annuvin)
gwydion4 = amatheon.beBorn(annuvin)
bran4 = amatheon.beBorn(annuvin)
amatheonwy0 = amatheon.beBorn(annuvin)
gwion0 = amatheon.beBorn(annuvin)
gwydion0 = amatheon.beBorn(annuvin)
bran0 = amatheon.beBorn(annuvin)
amatheonwy10 = amatheon.beBorn(annuvin)
gwion10 = amatheon.beBorn(annuvin)
gwydion10 = amatheon.beBorn(annuvin)
bran10 = amatheon.beBorn(annuvin)
amatheonwy20 = amatheon.beBorn(annuvin)
gwion20 = amatheon.beBorn(annuvin)
gwydion20 = amatheon.beBorn(annuvin)
bran20 = amatheon.beBorn(annuvin)
amatheonwy30 = amatheon.beBorn(annuvin)
gwion30 = amatheon.beBorn(annuvin)
gwydion30 = amatheon.beBorn(annuvin)
bran30 = amatheon.beBorn(annuvin)
amatheonwy40 = amatheon.beBorn(annuvin)
gwion40 = amatheon.beBorn(annuvin)
gwydion40 = amatheon.beBorn(annuvin)
bran40 = amatheon.beBorn(annuvin)
amatheonwy5 = amatheon.beBorn(annuvin)
gwion5 = amatheon.beBorn(annuvin)
gwydion5 = amatheon.beBorn(annuvin)
bran5 = amatheon.beBorn(annuvin)
amatheonwy15 = amatheon.beBorn(annuvin)
gwion15 = amatheon.beBorn(annuvin)
gwydion15 = amatheon.beBorn(annuvin)
bran15 = amatheon.beBorn(annuvin)
amatheonwy25 = amatheon.beBorn(annuvin)
gwion25 = amatheon.beBorn(annuvin)
gwydion25 = amatheon.beBorn(annuvin)
bran25 = amatheon.beBorn(annuvin)
amatheonwy35 = amatheon.beBorn(annuvin)
gwion35 = amatheon.beBorn(annuvin)
gwydion35 = amatheon.beBorn(annuvin)
bran35 = amatheon.beBorn(annuvin)
amatheonwy45 = amatheon.beBorn(annuvin)
gwion45 = amatheon.beBorn(annuvin)
gwydion45 = amatheon.beBorn(annuvin)
bran45 = amatheon.beBorn(annuvin)
amatheonwy7 = amatheon.beBorn(annuvin)
gwion7 = amatheon.beBorn(annuvin)
gwydion7 = amatheon.beBorn(annuvin)
bran7 = amatheon.beBorn(annuvin)
amatheonwy17 = amatheon.beBorn(annuvin)
gwion17 = amatheon.beBorn(annuvin)
gwydion17 = amatheon.beBorn(annuvin)
bran17 = amatheon.beBorn(annuvin)
amatheonwy27 = amatheon.beBorn(annuvin)
gwion27 = amatheon.beBorn(annuvin)
gwydion27 = amatheon.beBorn(annuvin)
bran27 = amatheon.beBorn(annuvin)
amatheonwy37 = amatheon.beBorn(annuvin)
gwion37 = amatheon.beBorn(annuvin)
gwydion37 = amatheon.beBorn(annuvin)
bran37 = amatheon.beBorn(annuvin)
amatheonwy47 = amatheon.beBorn(annuvin)
gwion47 = amatheon.beBorn(annuvin)
gwydion47 = amatheon.beBorn(annuvin)
bran47 = amatheon.beBorn(annuvin)
amatheonwy07 = amatheon.beBorn(annuvin)
gwion07 = amatheon.beBorn(annuvin)
gwydion07 = amatheon.beBorn(annuvin)
bran07 = amatheon.beBorn(annuvin)
amatheonwy107 = amatheon.beBorn(annuvin)
gwion107 = amatheon.beBorn(annuvin)
gwydion107 = amatheon.beBorn(annuvin)
bran107 = amatheon.beBorn(annuvin)
amatheonwy207 = amatheon.beBorn(annuvin)
gwion207 = amatheon.beBorn(annuvin)
gwydion207 = amatheon.beBorn(annuvin)
bran207 = amatheon.beBorn(annuvin)
amatheonwy307 = amatheon.beBorn(annuvin)
gwion307 = amatheon.beBorn(annuvin)
gwydion307 = amatheon.beBorn(annuvin)
bran307 = amatheon.beBorn(annuvin)
amatheonwy407 = amatheon.beBorn(annuvin)
gwion407 = amatheon.beBorn(annuvin)
gwydion407 = amatheon.beBorn(annuvin)
bran407 = amatheon.beBorn(annuvin)
amatheonwy57 = amatheon.beBorn(annuvin)
gwion57 = amatheon.beBorn(annuvin)
gwydion57 = amatheon.beBorn(annuvin)
bran57 = amatheon.beBorn(annuvin)
amatheonwy157 = amatheon.beBorn(annuvin)
gwion157 = amatheon.beBorn(annuvin)
gwydion157 = amatheon.beBorn(annuvin)
bran157 = amatheon.beBorn(annuvin)
amatheonwy257 = amatheon.beBorn(annuvin)
gwion257 = amatheon.beBorn(annuvin)
gwydion257 = amatheon.beBorn(annuvin)
bran257 = amatheon.beBorn(annuvin)
amatheonwy357 = amatheon.beBorn(annuvin)
gwion357 = amatheon.beBorn(annuvin)
gwydion357 = amatheon.beBorn(annuvin)
bran357 = amatheon.beBorn(annuvin)
amatheonwy457 = amatheon.beBorn(annuvin)
gwion457 = amatheon.beBorn(annuvin)
gwydion457 = amatheon.beBorn(annuvin)
bran457 = amatheon.beBorn(annuvin)


# manifest the agents on the grid
prydain.addAgent(bran)
prydain.addAgent(gwydion)
prydain.addAgent(amatheonwy)
prydain.addAgent(gwion)
prydain.addAgent(bran1)
prydain.addAgent(gwydion1)
prydain.addAgent(amatheonwy1)
prydain.addAgent(gwion1)
prydain.addAgent(bran2)
prydain.addAgent(gwydion2)
prydain.addAgent(amatheonwy2)
prydain.addAgent(gwion2)
prydain.addAgent(bran3)
prydain.addAgent(gwydion3)
prydain.addAgent(amatheonwy3)
prydain.addAgent(gwion3)
prydain.addAgent(bran4)
prydain.addAgent(gwydion4)
prydain.addAgent(amatheonwy4)
prydain.addAgent(gwion4)
prydain.addAgent(bran0)
prydain.addAgent(gwydion0)
prydain.addAgent(amatheonwy0)
prydain.addAgent(gwion0)
prydain.addAgent(bran10)
prydain.addAgent(gwydion10)
prydain.addAgent(amatheonwy10)
prydain.addAgent(gwion10)
prydain.addAgent(bran20)
prydain.addAgent(gwydion20)
prydain.addAgent(amatheonwy20)
prydain.addAgent(gwion20)
prydain.addAgent(bran30)
prydain.addAgent(gwydion30)
prydain.addAgent(amatheonwy30)
prydain.addAgent(gwion30)
prydain.addAgent(bran40)
prydain.addAgent(gwydion40)
prydain.addAgent(amatheonwy40)
prydain.addAgent(gwion40)
prydain.addAgent(bran5)
prydain.addAgent(gwydion5)
prydain.addAgent(amatheonwy5)
prydain.addAgent(gwion5)
prydain.addAgent(bran15)
prydain.addAgent(gwydion15)
prydain.addAgent(amatheonwy15)
prydain.addAgent(gwion15)
prydain.addAgent(bran25)
prydain.addAgent(gwydion25)
prydain.addAgent(amatheonwy25)
prydain.addAgent(gwion25)
prydain.addAgent(bran35)
prydain.addAgent(gwydion35)
prydain.addAgent(amatheonwy35)
prydain.addAgent(gwion35)
prydain.addAgent(bran45)
prydain.addAgent(gwydion45)
prydain.addAgent(amatheonwy45)
prydain.addAgent(gwion45)
prydain.addAgent(bran7)
prydain.addAgent(gwydion7)
prydain.addAgent(amatheonwy7)
prydain.addAgent(gwion7)
prydain.addAgent(bran17)
prydain.addAgent(gwydion17)
prydain.addAgent(amatheonwy17)
prydain.addAgent(gwion17)
prydain.addAgent(bran27)
prydain.addAgent(gwydion27)
prydain.addAgent(amatheonwy27)
prydain.addAgent(gwion27)
prydain.addAgent(bran37)
prydain.addAgent(gwydion37)
prydain.addAgent(amatheonwy37)
prydain.addAgent(gwion37)
prydain.addAgent(bran47)
prydain.addAgent(gwydion47)
prydain.addAgent(amatheonwy47)
prydain.addAgent(gwion47)
prydain.addAgent(bran07)
prydain.addAgent(gwydion07)
prydain.addAgent(amatheonwy07)
prydain.addAgent(gwion07)
prydain.addAgent(bran107)
prydain.addAgent(gwydion107)
prydain.addAgent(amatheonwy107)
prydain.addAgent(gwion107)
prydain.addAgent(bran207)
prydain.addAgent(gwydion207)
prydain.addAgent(amatheonwy207)
prydain.addAgent(gwion207)
prydain.addAgent(bran307)
prydain.addAgent(gwydion307)
prydain.addAgent(amatheonwy307)
prydain.addAgent(gwion307)
prydain.addAgent(bran407)
prydain.addAgent(gwydion407)
prydain.addAgent(amatheonwy407)
prydain.addAgent(gwion407)
prydain.addAgent(bran57)
prydain.addAgent(gwydion57)
prydain.addAgent(amatheonwy57)
prydain.addAgent(gwion57)
prydain.addAgent(bran157)
prydain.addAgent(gwydion157)
prydain.addAgent(amatheonwy157)
prydain.addAgent(gwion157)
prydain.addAgent(bran257)
prydain.addAgent(gwydion257)
prydain.addAgent(amatheonwy257)
prydain.addAgent(gwion257)
prydain.addAgent(bran357)
prydain.addAgent(gwydion357)
prydain.addAgent(amatheonwy357)
prydain.addAgent(gwion357)
prydain.addAgent(bran457)
prydain.addAgent(gwydion457)
prydain.addAgent(amatheonwy457)
prydain.addAgent(gwion457)

# seed the automaton with a live cell
prydain.set((10,10),1)


def main(stdscr):
    # a little workaround to make curses work for any terminal size
    (winheight,winwidth) = stdscr.getmaxyx()
    displaywidth = (winwidth < width) and winwidth-1 or width
    displayheight = (winheight < height) and winheight-1 or height
    # run the visual display refresh cycle as initialisation
    v.updateLoop(prydain, stdscr, displaywidth, displayheight)
    stdscr.refresh()

    # this is an iteration counter
    t = 0
    #print "t = %i\r" % (t)
    
    # the main iteration cycle
    for i in range(iterate):
        # update the automaton
        prydain.update()
        t = t+1
        # call a method from the dynamically compiled peoio to update the agents
        amatheon.wander(amatheonwy)
	amatheon.wander(gwion)
	amatheon.wander(gwydion)
	amatheon.wander(bran)
        amatheon.wander(amatheonwy1)
	amatheon.wander(gwion1)
	amatheon.wander(gwydion1)
	amatheon.wander(bran1)
        amatheon.wander(amatheonwy2)
	amatheon.wander(gwion2)
	amatheon.wander(gwydion2)
	amatheon.wander(bran2)
        amatheon.wander(amatheonwy3)
	amatheon.wander(gwion3)
	amatheon.wander(gwydion3)
	amatheon.wander(bran3)
        amatheon.wander(amatheonwy4)
	amatheon.wander(gwion4)
	amatheon.wander(gwydion4)
	amatheon.wander(bran4)
        amatheon.wander(amatheonwy0)
	amatheon.wander(gwion0)
	amatheon.wander(gwydion0)
	amatheon.wander(bran0)
        amatheon.wander(amatheonwy10)
	amatheon.wander(gwion10)
	amatheon.wander(gwydion10)
	amatheon.wander(bran10)
        amatheon.wander(amatheonwy20)
	amatheon.wander(gwion20)
	amatheon.wander(gwydion20)
	amatheon.wander(bran20)
        amatheon.wander(amatheonwy30)
	amatheon.wander(gwion30)
	amatheon.wander(gwydion30)
	amatheon.wander(bran30)
        amatheon.wander(amatheonwy40)
	amatheon.wander(gwion40)
	amatheon.wander(gwydion40)
	amatheon.wander(bran40)
        amatheon.wander(amatheonwy5)
	amatheon.wander(gwion5)
	amatheon.wander(gwydion5)
	amatheon.wander(bran5)
        amatheon.wander(amatheonwy15)
	amatheon.wander(gwion15)
	amatheon.wander(gwydion15)
	amatheon.wander(bran15)
        amatheon.wander(amatheonwy25)
	amatheon.wander(gwion25)
	amatheon.wander(gwydion25)
	amatheon.wander(bran25)
        amatheon.wander(amatheonwy35)
	amatheon.wander(gwion35)
	amatheon.wander(gwydion35)
	amatheon.wander(bran35)
        amatheon.wander(amatheonwy45)
	amatheon.wander(gwion45)
	amatheon.wander(gwydion45)
	amatheon.wander(bran45)
        amatheon.wander(amatheonwy7)
	amatheon.wander(gwion7)
	amatheon.wander(gwydion7)
	amatheon.wander(bran7)
        amatheon.wander(amatheonwy17)
	amatheon.wander(gwion17)
	amatheon.wander(gwydion17)
	amatheon.wander(bran17)
        amatheon.wander(amatheonwy27)
	amatheon.wander(gwion27)
	amatheon.wander(gwydion27)
	amatheon.wander(bran27)
        amatheon.wander(amatheonwy37)
	amatheon.wander(gwion37)
	amatheon.wander(gwydion37)
	amatheon.wander(bran37)
        amatheon.wander(amatheonwy47)
	amatheon.wander(gwion47)
	amatheon.wander(gwydion47)
	amatheon.wander(bran47)
        amatheon.wander(amatheonwy07)
	amatheon.wander(gwion07)
	amatheon.wander(gwydion07)
	amatheon.wander(bran07)
        amatheon.wander(amatheonwy107)
	amatheon.wander(gwion107)
	amatheon.wander(gwydion107)
	amatheon.wander(bran107)
        amatheon.wander(amatheonwy207)
	amatheon.wander(gwion207)
	amatheon.wander(gwydion207)
	amatheon.wander(bran207)
        amatheon.wander(amatheonwy307)
	amatheon.wander(gwion307)
	amatheon.wander(gwydion307)
	amatheon.wander(bran307)
        amatheon.wander(amatheonwy407)
	amatheon.wander(gwion407)
	amatheon.wander(gwydion407)
	amatheon.wander(bran407)
        amatheon.wander(amatheonwy57)
	amatheon.wander(gwion57)
	amatheon.wander(gwydion57)
	amatheon.wander(bran57)
        amatheon.wander(amatheonwy157)
	amatheon.wander(gwion157)
	amatheon.wander(gwydion157)
	amatheon.wander(bran157)
        amatheon.wander(amatheonwy257)
	amatheon.wander(gwion257)
	amatheon.wander(gwydion257)
	amatheon.wander(bran257)
        amatheon.wander(amatheonwy357)
	amatheon.wander(gwion357)
	amatheon.wander(gwydion357)
	amatheon.wander(bran357)
        amatheon.wander(amatheonwy457)
	amatheon.wander(gwion457)
	amatheon.wander(gwydion457)
	amatheon.wander(bran457)
        # run the visual display refresh cycle
    	v.updateLoop(prydain, stdscr, displaywidth, displayheight)
        stdscr.refresh()
        #print "t = %i" % (t)
    raw_input("Done")

# call the generic curses wrapper to maintain terminal sanity in all events
if __name__ == '__main__': c.wrapper(main)
